import { createLayoutState, createProjectionState } from '../../utils/state.js';
import { buildSVGAttrs } from './build-svg-attrs.js';
import { createSvgRenderState } from './create-svg-render-state.js';
import { useMemo } from 'react';
import { useStyle } from './use-html-props.js';

function useInitialMotionProps(props, visualState) {
    return useMemo(function () {
        var state = createSvgRenderState();
        buildSVGAttrs(state, visualState, createProjectionState(), createLayoutState(), { enableHardwareAcceleration: false }, props.transformTemplate);
        return state.attrs;
    }, [visualState]);
}
function useSVGProps(props, visualState, isStatic) {
    var svgProps = useInitialMotionProps(props, visualState);
    // TODO: This is calling both SVG and HTML useInitialMotioNprops
    var style = useStyle(props, visualState, isStatic);
    // TODO: Figure out why these aren't being removed
    delete style.transform;
    delete style.transformOrigin;
    svgProps.style = style;
    return svgProps;
}

export { useSVGProps };
